(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    104561,       2584]
NotebookOptionsPosition[    104237,       2568]
NotebookOutlinePosition[    104579,       2583]
CellTagsIndexPosition[    104536,       2580]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "This", " ", "Section", " ", "transforms", " ", "ODE", " ", "into", " ", 
    "polynomial", " ", "ones"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"varCounter", " ", "=", " ", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"varName", " ", "=", " ", "\"\<w\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NewVar", " ", ":=", " ", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "res", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"res", "=", 
         RowBox[{"ToExpression", "[", 
          RowBox[{"varName", "<>", 
           RowBox[{"ToString", "[", "varCounter", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"varCounter", "++"}], ";", "\[IndentingNewLine]", "res"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParseExpr", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"exprHead", ",", "res"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"IsConstant", "[", 
          RowBox[{"diff", ",", "var"}], "]"}], ",", 
         RowBox[{"ParseConst", "[", 
          RowBox[{"diff", ",", "var", ",", "factor"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"exprHead", " ", "=", " ", 
           RowBox[{"Head", "[", "diff", "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Switch", "[", 
           RowBox[{
           "exprHead", ",", " ", "\[IndentingNewLine]", "Symbol", ",", " ", 
            RowBox[{"ParseAtom", "[", 
             RowBox[{"diff", ",", "var", ",", "factor"}], "]"}], ",", 
            "\[IndentingNewLine]", "Sin", ",", " ", 
            RowBox[{"ParseSin", "[", 
             RowBox[{"diff", ",", "var", ",", "factor"}], "]"}], ",", 
            "\[IndentingNewLine]", "Cos", ",", " ", 
            RowBox[{"ParseCos", "[", 
             RowBox[{"diff", ",", "var", ",", "factor"}], "]"}], ",", 
            "\[IndentingNewLine]", "Plus", ",", " ", 
            RowBox[{"ParsePlus", "[", 
             RowBox[{"diff", ",", "var", ",", "factor"}], "]"}], ",", 
            "\[IndentingNewLine]", "Times", ",", " ", 
            RowBox[{"ParseTimes", "[", 
             RowBox[{"diff", ",", "var", ",", "factor"}], "]"}], ",", 
            "\[IndentingNewLine]", "Log", ",", " ", 
            RowBox[{"ParseLog", "[", 
             RowBox[{"diff", ",", "var", ",", "factor"}], "]"}], ",", 
            "\[IndentingNewLine]", "Power", ",", " ", 
            RowBox[{"ParsePower", "[", 
             RowBox[{"diff", ",", "var", ",", "factor"}], "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParsePower", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"base", ",", "expo", ",", "res"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"base", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"expo", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"res", " ", "=", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"IsConstant", "[", 
           RowBox[{"base", ",", "var"}], "]"}], ",", 
          RowBox[{"res", "=", 
           RowBox[{"ParseExpo", "[", 
            RowBox[{"diff", ",", "var", ",", "factor"}], "]"}]}], ",", 
          RowBox[{"res", "=", 
           RowBox[{"ParsePower2", "[", 
            RowBox[{"diff", ",", "var", ",", "factor"}], "]"}]}]}], "]"}], 
        ";", "\[IndentingNewLine]", "res"}]}], "\[IndentingNewLine]", "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParseExpo", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "base", ",", "expo", ",", "res", ",", "op", ",", "opExpr", ",", 
         "opODE", ",", "opPara", ",", "v", ",", "opD", ",", "ode", ",", 
         "deria", ",", "value", ",", "para", ",", "rpRule", ",", 
         "rpRuleSet"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"base", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"expo", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"op", " ", "=", "  ", "expo"}], ";", "\[IndentingNewLine]", 
        RowBox[{"opExpr", "=", 
         RowBox[{"ParseExpr", " ", "[", 
          RowBox[{"op", ",", "var", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"opPara", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"opODE", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"v", " ", "=", " ", "NewVar"}], ";", "\[IndentingNewLine]", 
        RowBox[{"para", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{"opPara", ",", " ", "v"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"opD", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ode", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{"opODE", ",", " ", 
           RowBox[{
            RowBox[{"Log", "[", "base", "]"}], "*", "v", "*", "opD"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"deria", " ", "=", "  ", 
         RowBox[{
          RowBox[{"Log", "[", "base", "]"}], "*", "v", "*", "opD"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"value", " ", "=", " ", "v"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"rpRule", "=", 
         RowBox[{"v", "\[Rule]", " ", 
          RowBox[{"factor", "*", "diff"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"AppendTo", "[", 
          RowBox[{
           RowBox[{"opExpr", "[", 
            RowBox[{"[", "5", "]"}], "]"}], ",", "rpRule"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", 
          RowBox[{
          "para", ",", "ode", ",", "deria", ",", "value", ",", "rpRuleSet"}], 
          "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParsePower2", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"base", ",", "expo", ",", "res", ",", "expoHead"}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"base", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"expo", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"expoHead", " ", "=", " ", 
         RowBox[{"Head", "[", "expo", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"res", " ", "=", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Switch", "[", 
         RowBox[{"expoHead", ",", "\[IndentingNewLine]", "Integer", ",", " ", 
          RowBox[{"res", " ", "=", " ", 
           RowBox[{"ParsePowerInteger", "[", 
            RowBox[{"diff", ",", "var", ",", "factor"}], "]"}]}], ",", 
          "\[IndentingNewLine]", "Rational", ",", " ", 
          RowBox[{"res", " ", "=", " ", 
           RowBox[{"ParsePowerRational", "[", 
            RowBox[{"diff", ",", "var", ",", "factor"}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", "res"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParsePowerRational", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "base", ",", "expo", ",", "res", ",", "op", ",", "opExpr", ",", 
         "opODE", ",", "opPara", ",", "v", ",", "u", ",", "opD", ",", "ode", 
         ",", "deria", ",", "value", ",", "para", ",", "deno", ",", "num", 
         ",", "opV", ",", " ", "rpRuleSet", ",", "rpRule"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"base", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"expo", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"deno", " ", "=", " ", 
         RowBox[{"Denominator", "[", "expo", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"num", "=", 
         RowBox[{"expo", "*", "deno"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"op", " ", "=", "  ", 
         RowBox[{"base", "^", "num"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"opExpr", "=", 
         RowBox[{"ParseExpr", " ", "[", 
          RowBox[{"op", ",", "var", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"opPara", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"opODE", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"v", "=", "NewVar"}], ";", "\[IndentingNewLine]", 
        RowBox[{"u", "=", "NewVar"}], ";", "\[IndentingNewLine]", 
        RowBox[{"para", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"opPara", ",", " ", "v"}], "]"}], ",", "u"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"opD", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"opV", "=", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "4", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ode", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"opODE", ",", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"factor", "^", "deno"}], ")"}], "*", 
              RowBox[{"(", 
               RowBox[{"1", "/", "deno"}], ")"}], "*", "u", "*", "opD"}]}], 
            "]"}], ",", "  ", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", "deno"}], ")"}], "/", "deno"}], "*", "u", "*",
             "opD", "*", 
            RowBox[{"(", 
             RowBox[{"1", "/", "opV"}], ")"}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"deria", " ", "=", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"factor", "^", "deno"}], ")"}], "*", 
          RowBox[{"(", 
           RowBox[{"1", "/", "deno"}], ")"}], "*", "u", "*", "opD"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"value", " ", "=", " ", "v"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"rpRule", "=", 
         RowBox[{"v", "\[Rule]", " ", 
          RowBox[{"factor", "*", "diff"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"AppendTo", "[", 
          RowBox[{
           RowBox[{"opExpr", "[", 
            RowBox[{"[", "5", "]"}], "]"}], ",", "rpRule"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", 
          RowBox[{
          "para", ",", "ode", ",", "deria", ",", "value", ",", "rpRuleSet"}], 
          "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParsePowerInteger", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"base", ",", "expo", ",", "res"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"base", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"expo", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"res", " ", "=", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"expo", "<", "0"}], ",", 
          RowBox[{"res", "=", 
           RowBox[{"ParseNegInt", "[", 
            RowBox[{"diff", ",", "var", ",", "factor"}], "]"}]}], ",", 
          RowBox[{"res", "=", 
           RowBox[{"ParsePosInt", "[", 
            RowBox[{"diff", ",", "var", ",", "factor"}], "]"}]}]}], "]"}], 
        ";", "\[IndentingNewLine]", "res"}]}], "\[IndentingNewLine]", "]"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParseNegInt", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "base", ",", "expo", ",", "res", ",", "op", ",", "opExpr", ",", 
         "opODE", ",", "opPara", ",", "v", ",", "opD", ",", "ode", ",", 
         "deria", ",", "value", ",", "para", ",", " ", "rpRuleSet", ",", " ", 
         "rpRule"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"base", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"expo", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"op", " ", "=", "  ", 
         RowBox[{"base", "^", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "*", "expo"}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"opExpr", "=", 
         RowBox[{"ParseExpr", " ", "[", 
          RowBox[{"op", ",", "var", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"opPara", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"opODE", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"v", " ", "=", " ", "NewVar"}], ";", "\[IndentingNewLine]", 
        RowBox[{"para", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{"opPara", ",", " ", "v"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"opD", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ode", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{"opODE", ",", " ", 
           RowBox[{
            RowBox[{"-", "1"}], "*", 
            RowBox[{"v", "^", "2"}], "*", "opD", "*", 
            RowBox[{"(", 
             RowBox[{"1", "/", "factor"}], ")"}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"deria", " ", "=", "  ", 
         RowBox[{
          RowBox[{"-", "1"}], "*", 
          RowBox[{"v", "^", "2"}], "*", "opD", "*", 
          RowBox[{"(", 
           RowBox[{"1", "/", "factor"}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"value", " ", "=", " ", "v"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"rpRule", "=", 
         RowBox[{"v", "\[Rule]", " ", 
          RowBox[{"factor", "*", "diff"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"AppendTo", "[", 
          RowBox[{
           RowBox[{"opExpr", "[", 
            RowBox[{"[", "5", "]"}], "]"}], ",", "rpRule"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", 
          RowBox[{
          "para", ",", "ode", ",", "deria", ",", "value", ",", "rpRuleSet"}], 
          "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParsePosInt", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "base", ",", "expo", ",", "res", ",", "op", ",", "opExpr", ",", 
         "opODE", ",", "opPara", ",", "opD", ",", "ode", ",", "deria", ",", 
         "value", ",", "para", ",", " ", "rpRuleSet", ",", "rpRule"}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"base", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"expo", " ", "=", " ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"op", " ", "=", "  ", "base"}], ";", "\[IndentingNewLine]", 
        RowBox[{"opExpr", "=", 
         RowBox[{"ParseExpr", " ", "[", 
          RowBox[{"op", ",", "var", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"opPara", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"opODE", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"para", " ", "=", " ", "opPara"}], ";", "\[IndentingNewLine]", 
        RowBox[{"opD", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ode", " ", "=", " ", "opODE"}], ";", "\[IndentingNewLine]", 
        RowBox[{"deria", " ", "=", "  ", 
         RowBox[{"expo", "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"opExpr", "[", 
             RowBox[{"[", "4", "]"}], "]"}], ")"}], "^", 
           RowBox[{"(", 
            RowBox[{"expo", "-", "1"}], ")"}]}], "*", "opD", "*", 
          "factor"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"value", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"opExpr", "[", 
             RowBox[{"[", "4", "]"}], "]"}], ")"}], "^", "expo"}], "*", 
          "factor"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"rpRule", "=", 
         RowBox[{"v", "\[Rule]", " ", 
          RowBox[{"factor", "*", "diff"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"AppendTo", "[", 
          RowBox[{
           RowBox[{"opExpr", "[", 
            RowBox[{"[", "5", "]"}], "]"}], ",", "rpRule"}], "]"}]}], ";", 
        "\[IndentingNewLine]", " ", "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", 
          RowBox[{
          "para", ",", "ode", ",", "deria", ",", "value", ",", "rpRuleSet"}], 
          "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParseConst", "[", 
      RowBox[{"c_", ",", "var_", ",", "factor_"}], "]"}], " ", ":=", " ", 
     RowBox[{"Module", " ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "para", ",", "ode", ",", "deria", ",", "value", ",", " ", "res", ",", 
         " ", "rpRuleSet"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"para", " ", "=", " ", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ode", " ", "=", " ", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"deria", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"value", " ", "=", " ", 
         RowBox[{"c", "*", "factor"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"{", "}"}]}], ";", " ", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", 
          RowBox[{
          "para", ",", "ode", ",", "deria", ",", "value", ",", "rpRuleSet"}], 
          "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParseAtom", "[", 
      RowBox[{"x_", ",", "var_", ",", "factor_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "para", ",", " ", "ode", ",", "deria", ",", "value", ",", "res", ",", 
         " ", "rpRuleSet"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"para", " ", "=", " ", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ode", " ", "=", " ", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"deria", " ", "=", " ", 
         RowBox[{
          RowBox[{"x", "'"}], "*", "factor"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"value", " ", "=", " ", 
         RowBox[{"x", "*", "factor"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"{", "}"}]}], ";", " ", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", 
          RowBox[{
          "para", ",", "ode", ",", "deria", ",", "value", ",", "rpRuleSet"}], 
          "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParsePlus", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], " ", ":=", " ", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "para", ",", " ", "ode", ",", " ", "res", ",", " ", "op1", ",", "op2",
          ",", " ", "op1Expr", ",", "op2Expr", ",", " ", "op1Para", ",", 
         "op1ODE", ",", "op2Para", ",", "op2ODE", ",", " ", "tmpVar", ",", 
         "tmpODE", ",", "deria", ",", "value", ",", " ", "rpRuleSet"}], "}"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"op1", "=", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"op2", "=", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"op1Expr", "=", 
         RowBox[{"ParseExpr", " ", "[", 
          RowBox[{"op1", ",", "var", ",", "factor"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"op2Expr", "=", 
         RowBox[{"ParseExpr", "[", 
          RowBox[{"op2", ",", "var", ",", "factor"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"op1Para", " ", "=", " ", 
         RowBox[{"op1Expr", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"op1ODE", " ", "=", " ", 
         RowBox[{"op1Expr", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"op2Para", "=", " ", 
         RowBox[{"op2Expr", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"op2ODE", "=", 
         RowBox[{"op2Expr", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "op1Para", "]"}], "\[NotEqual]", "0"}], 
           " ", "&&", " ", 
           RowBox[{
            RowBox[{"Length", "[", "op2Para", "]"}], "\[NotEqual]", "0"}]}], 
          ",", " ", "\[IndentingNewLine]", " ", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"tmpVar", "=", "NewVar"}], ";", "\[IndentingNewLine]", 
           RowBox[{"para", " ", "=", " ", 
            RowBox[{"Append", "[", 
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{"op1Para", ",", " ", "op2Para"}], "]"}], ",", 
              "tmpVar"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"tmpODE", " ", "=", " ", 
            RowBox[{
             RowBox[{"op1Expr", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "+", 
             RowBox[{"op2Expr", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"ode", " ", "=", " ", 
            RowBox[{"Append", "[", 
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{"op1ODE", ",", "op2ODE"}], "]"}], ",", " ", "tmpODE"}],
              "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"deria", " ", "=", " ", "tmpODE"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"value", " ", "=", " ", "tmpVar"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"para", " ", "=", " ", 
            RowBox[{"Join", "[", 
             RowBox[{"op1Para", ",", " ", "op2Para"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ode", " ", "=", 
            RowBox[{"Join", "[", 
             RowBox[{"op1ODE", ",", "op2ODE"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"deria", " ", "=", " ", 
            RowBox[{
             RowBox[{"op1Expr", "[", 
              RowBox[{"[", "3", "]"}], "]"}], " ", "+", " ", 
             RowBox[{"op2Expr", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"value", " ", "=", " ", 
            RowBox[{
             RowBox[{"op1Expr", "[", 
              RowBox[{"[", "4", "]"}], "]"}], "+", 
             RowBox[{"op2Expr", "[", 
              RowBox[{"[", "4", "]"}], "]"}]}]}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"op1Expr", "[", 
            RowBox[{"[", "5", "]"}], "]"}], ",", 
           RowBox[{"op2Expr", "[", 
            RowBox[{"[", "5", "]"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", 
          RowBox[{
          "para", ",", "ode", ",", "deria", ",", "value", ",", "rpRuleSet"}], 
          "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParseTimes", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], " ", ":=", " ", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "para", ",", " ", "ode", ",", " ", "res", ",", " ", "op1", ",", "op2",
          ",", " ", "op1Expr", ",", "op2Expr", ",", " ", "op1Para", ",", 
         "op1ODE", ",", "op2Para", ",", "op2ODE", ",", " ", "tmpVar", ",", 
         "tmpODE", ",", "deria", ",", "value", ",", " ", "rpRuleSet"}], "}"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"op1", "=", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"op2", "=", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"!", 
            RowBox[{"IsConstant", "[", 
             RowBox[{"op1", ",", "var"}], "]"}]}], "&&", 
           RowBox[{"!", 
            RowBox[{"IsConstant", "[", 
             RowBox[{"op2", ",", "var"}], "]"}]}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "If", " ", "both", " ", "multiplier", " ", "are", " ", "not", " ", 
            "consant"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"op1Expr", "=", 
            RowBox[{"ParseExpr", " ", "[", 
             RowBox[{"op1", ",", "var", ",", "factor"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"op2Expr", "=", 
            RowBox[{"ParseExpr", "[", 
             RowBox[{"op2", ",", "var", ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"op1Para", " ", "=", " ", 
            RowBox[{"op1Expr", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"op1ODE", " ", "=", " ", 
            RowBox[{"op1Expr", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"op2Para", "=", " ", 
            RowBox[{"op2Expr", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"op2ODE", "=", 
            RowBox[{"op2Expr", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Length", "[", "op1Para", "]"}], "\[NotEqual]", "0"}], 
              " ", "&&", " ", 
              RowBox[{
               RowBox[{"Length", "[", "op2Para", "]"}], "\[NotEqual]", 
               "0"}]}], ",", " ", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"tmpVar", "=", "NewVar"}], ";", "\[IndentingNewLine]", 
              RowBox[{"para", " ", "=", " ", 
               RowBox[{"Append", "[", 
                RowBox[{
                 RowBox[{"Join", "[", 
                  RowBox[{"op1Para", ",", " ", "op2Para"}], "]"}], ",", 
                 "tmpVar"}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"tmpODE", " ", "=", " ", 
               RowBox[{
                RowBox[{"op1", "*", 
                 RowBox[{"op2Expr", "[", 
                  RowBox[{"[", "3", "]"}], "]"}]}], "+", 
                RowBox[{"op2", "*", 
                 RowBox[{"op1Expr", "[", 
                  RowBox[{"[", "3", "]"}], "]"}]}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"ode", " ", "=", " ", 
               RowBox[{"Append", "[", 
                RowBox[{
                 RowBox[{"Join", "[", 
                  RowBox[{"op1ODE", ",", "op2ODE"}], "]"}], ",", " ", 
                 "tmpODE"}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"deria", " ", "=", " ", "tmpODE"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"value", " ", "=", " ", "tmpVar"}]}], ",", " ", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"para", " ", "=", " ", 
               RowBox[{"Join", "[", 
                RowBox[{"op1Para", ",", " ", "op2Para"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"ode", " ", "=", 
               RowBox[{"Join", "[", 
                RowBox[{"op1ODE", ",", "op2ODE"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"deria", " ", "=", " ", 
               RowBox[{
                RowBox[{"op1", "*", 
                 RowBox[{"op2Expr", "[", 
                  RowBox[{"[", "3", "]"}], "]"}]}], "+", 
                RowBox[{"op2", "*", 
                 RowBox[{"op1Expr", "[", 
                  RowBox[{"[", "3", "]"}], "]"}]}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"value", " ", "=", " ", 
               RowBox[{
                RowBox[{"op1Expr", "[", 
                 RowBox[{"[", "4", "]"}], "]"}], "*", 
                RowBox[{"op2Expr", "[", 
                 RowBox[{"[", "4", "]"}], "]"}]}]}]}]}], 
            "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"IsConstant", "[", 
             RowBox[{"op1", ",", "var"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"op1", " ", "is", " ", "constant"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"op1Expr", "=", 
              RowBox[{"ParseExpr", " ", "[", 
               RowBox[{"op1", ",", "var", ",", "1"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"op2Expr", "=", 
              RowBox[{"ParseExpr", "[", 
               RowBox[{"op2", ",", "var", ",", 
                RowBox[{"factor", "*", "op1"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"op1Para", " ", "=", " ", 
              RowBox[{"op1Expr", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"op1ODE", " ", "=", " ", 
              RowBox[{"op1Expr", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"op2Para", "=", " ", 
              RowBox[{"op2Expr", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"op2ODE", "=", 
              RowBox[{"op2Expr", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"para", " ", "=", " ", 
              RowBox[{"Join", "[", 
               RowBox[{"op1Para", ",", " ", "op2Para"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"ode", " ", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"op1ODE", ",", "op2ODE"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"deria", " ", "=", " ", 
              RowBox[{
               RowBox[{"op1", "*", 
                RowBox[{"op2Expr", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}], "+", 
               RowBox[{"op2", "*", 
                RowBox[{"op1Expr", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"value", " ", "=", " ", 
              RowBox[{"op2Expr", "[", 
               RowBox[{"[", "4", "]"}], "]"}]}]}], ",", "\[IndentingNewLine]",
             "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"op2", " ", "is", " ", "constant"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"op1Expr", "=", 
              RowBox[{"ParseExpr", " ", "[", 
               RowBox[{"op1", ",", "var", ",", 
                RowBox[{"factor", "*", "op2"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"op2Expr", "=", 
              RowBox[{"ParseExpr", "[", 
               RowBox[{"op2", ",", "var", ",", "1"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"op1Para", " ", "=", " ", 
              RowBox[{"op1Expr", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"op1ODE", " ", "=", " ", 
              RowBox[{"op1Expr", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"op2Para", "=", " ", 
              RowBox[{"op2Expr", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"op2ODE", "=", 
              RowBox[{"op2Expr", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"para", " ", "=", " ", 
              RowBox[{"Join", "[", 
               RowBox[{"op1Para", ",", " ", "op2Para"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"ode", " ", "=", 
              RowBox[{"Join", "[", 
               RowBox[{"op1ODE", ",", "op2ODE"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"deria", " ", "=", " ", 
              RowBox[{
               RowBox[{"op1", "*", 
                RowBox[{"op2Expr", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}], "+", 
               RowBox[{"op2", "*", 
                RowBox[{"op1Expr", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"value", " ", "=", " ", 
              RowBox[{"op1Expr", "[", 
               RowBox[{"[", "4", "]"}], "]"}]}]}]}], "\[IndentingNewLine]", 
           "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"op1Expr", "[", 
            RowBox[{"[", "5", "]"}], "]"}], ",", 
           RowBox[{"op2Expr", "[", 
            RowBox[{"[", "5", "]"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", 
          RowBox[{
          "para", ",", "ode", ",", "deria", ",", "value", ",", "rpRuleSet"}], 
          "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParseSin", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], " ", ":=", " ", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "para", ",", " ", "ode", ",", " ", "res", ",", " ", "op", ",", " ", 
         "opExpr", ",", "opODE", ",", "opPara", ",", "opD", ",", "v", ",", 
         "u", ",", "deria", ",", "value", ",", " ", "rpRuleSet", ",", 
         "rpRule"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"op", " ", "=", "  ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"opExpr", "=", 
         RowBox[{"ParseExpr", " ", "[", 
          RowBox[{"op", ",", "var", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"opPara", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"opODE", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"v", "=", "NewVar"}], ";", " ", "\[IndentingNewLine]", 
        RowBox[{"u", "=", "NewVar"}], ";", "\[IndentingNewLine]", 
        RowBox[{"para", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"opPara", ",", " ", "v"}], "]"}], ",", "u"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"opD", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ode", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"opODE", ",", " ", 
             RowBox[{"factor", "*", "u", "*", "opD"}]}], "]"}], ",", "  ", 
           RowBox[{
            RowBox[{"-", "1"}], "*", "v", "*", "opD", "*", 
            RowBox[{"(", 
             RowBox[{"1", "/", "factor"}], ")"}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"deria", " ", "=", " ", 
         RowBox[{"u", "*", "opD", "*", "factor"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"value", " ", "=", " ", "v"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"rpRule", "=", 
         RowBox[{"v", "\[Rule]", " ", 
          RowBox[{"factor", "*", "diff"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"AppendTo", "[", 
          RowBox[{
           RowBox[{"opExpr", "[", 
            RowBox[{"[", "5", "]"}], "]"}], ",", "rpRule"}], "]"}]}], ";", 
        "\[IndentingNewLine]", " ", "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", 
          RowBox[{
          "para", ",", "ode", ",", "deria", ",", "value", ",", "rpRuleSet"}], 
          "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParseCos", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], " ", ":=", " ", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "para", ",", " ", "ode", ",", " ", "res", ",", " ", "op", ",", " ", 
         "opExpr", ",", "opODE", ",", "opPara", ",", "opD", ",", "v", ",", 
         "u", ",", " ", "deria", ",", "value", ",", " ", "rpRuleSet", ",", 
         "rpRule"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"op", " ", "=", "  ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"opExpr", "=", 
         RowBox[{"ParseExpr", " ", "[", 
          RowBox[{"op", ",", "var", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"opPara", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", " ", "\[IndentingNewLine]", 
        RowBox[{"opODE", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"v", "=", "NewVar"}], ";", "\[IndentingNewLine]", 
        RowBox[{"u", "=", "NewVar"}], ";", "\[IndentingNewLine]", 
        RowBox[{"para", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"opPara", ",", " ", "v"}], "]"}], ",", "u"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"opD", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ode", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"opODE", ",", " ", 
             RowBox[{
              RowBox[{"-", "1"}], "*", "u", "*", "opD", "*", "factor"}]}], 
            "]"}], ",", " ", 
           RowBox[{"v", "*", "opD", "*", 
            RowBox[{"(", 
             RowBox[{"1", "/", "factor"}], ")"}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"deria", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "1"}], "*", "u", "*", "opD", "*", "factor"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"value", " ", "=", " ", "v"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"rpRule", "=", 
         RowBox[{"v", "\[Rule]", " ", 
          RowBox[{"factor", "*", "diff"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"AppendTo", "[", 
          RowBox[{
           RowBox[{"opExpr", "[", 
            RowBox[{"[", "5", "]"}], "]"}], ",", "rpRule"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", 
          RowBox[{
          "para", ",", "ode", ",", "deria", ",", "value", ",", "rpRuleSet"}], 
          "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ParseLog", "[", 
      RowBox[{"diff_", ",", "var_", ",", "factor_"}], "]"}], " ", ":=", " ", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "para", ",", " ", "ode", ",", " ", "res", ",", " ", "op", ",", " ", 
         "opExpr", ",", "opODE", ",", "opPara", ",", "opD", ",", "v", ",", 
         "u", ",", " ", "deria", ",", "value", ",", " ", "rpRuleSet", ",", 
         "rpRule"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"op", " ", "=", "  ", 
         RowBox[{"diff", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"opExpr", "=", 
         RowBox[{"ParseExpr", " ", "[", 
          RowBox[{"op", ",", "var", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"opPara", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", " ", "\[IndentingNewLine]", 
        RowBox[{"opODE", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"v", "=", "NewVar"}], ";", "\[IndentingNewLine]", 
        RowBox[{"u", "=", "NewVar"}], ";", "\[IndentingNewLine]", 
        RowBox[{"para", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"opPara", ",", " ", "v"}], "]"}], ",", "u"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"opD", " ", "=", " ", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ode", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"opODE", ",", " ", 
             RowBox[{"factor", "*", "u", "*", "opD"}]}], "]"}], ",", " ", 
           RowBox[{
            RowBox[{"-", "1"}], "*", 
            RowBox[{"u", "^", "2"}], "*", "opD"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"deria", " ", "=", " ", 
         RowBox[{"u", "*", "opD", "*", "factor"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"value", " ", "=", " ", "v"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"rpRule", "=", 
         RowBox[{"v", "\[Rule]", 
          RowBox[{"factor", "*", "diff"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"opExpr", "[", 
          RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", 
          RowBox[{
          "para", ",", "ode", ",", "deria", ",", "value", ",", "rpRuleSet"}], 
          "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IsConstant", "[", 
      RowBox[{"expr_", ",", "var_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "res", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"IsExprZero", "[", 
          RowBox[{"D", "[", 
           RowBox[{"expr", ",", 
            RowBox[{"{", "var", "}"}]}], "]"}], "]"}], ",", "True", ",", 
         "False"}], "]"}]}], " ", "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IsExprZero", "[", "expr_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"res", ",", "i", ",", "len"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"res", "=", "True"}], ";", " ", "\[IndentingNewLine]", 
        RowBox[{"len", "=", 
         RowBox[{"Length", "[", "expr", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"len", "\[Equal]", "0"}], ",", " ", "\[IndentingNewLine]", 
          RowBox[{"res", "=", 
           RowBox[{"IsConstZero", "[", "expr", "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "1"}], ",", 
            RowBox[{"i", "\[LessEqual]", " ", 
             RowBox[{"Length", "[", "expr", "]"}]}], ",", 
            RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"res", "=", 
             RowBox[{"res", "&&", " ", 
              RowBox[{"IsExprZero", "[", 
               RowBox[{"expr", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "]"}]}]}]}], 
           "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "res"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IsConstZero", "[", "expr_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"res", ",", "strExpr"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"strExpr", "=", 
         RowBox[{"ToString", "[", "expr", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"strExpr", "\[Equal]", "\"\<0\>\""}], ",", "True", ",", 
          "False"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PolyDiff", "[", 
      RowBox[{"Para_", ",", "Diff_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "resDiff", ",", "tmp", ",", " ", "exprBef", ",", " ", "exprAfter", 
         ",", "res", ",", "para", ",", "diff", ",", "i", ",", "j", ",", 
         "rpRuleSet", ",", "rpRule", ",", "rpVar", ",", "delVarIdx", ",", 
         "finalVar", ",", "finalD", ",", "rprVariants", ",", "rprLeft", ",", 
         "rprRight", ",", "rpr2Equation", ",", "varlist"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"resDiff", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", " ", 
          RowBox[{"i", "\[LessEqual]", " ", 
           RowBox[{"Length", "[", "Diff", "]"}]}], ",", " ", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"para", " ", "=", " ", 
            RowBox[{"Para", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], ";", " ", 
           "\[IndentingNewLine]", 
           RowBox[{"diff", "=", 
            RowBox[{"Diff", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"tmp", " ", "=", " ", 
            RowBox[{"ParseExpr", "[", 
             RowBox[{"diff", ",", "Para", ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"resDiff", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"resDiff", ",", " ", "tmp"}], "]"}]}], ";"}]}], " ", 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"res", " ", "=", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", " ", 
           RowBox[{"Length", "[", "resDiff", "]"}]}], ",", " ", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"res", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"res", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"resDiff", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"res", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"resDiff", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "}"}]}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", " ", 
           RowBox[{"Length", "[", "Para", "]"}]}], ",", " ", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"exprBef", " ", "=", " ", 
            RowBox[{
             RowBox[{"Para", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "'"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"exprAfter", " ", "=", " ", 
            RowBox[{
             RowBox[{"resDiff", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "4", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"res", " ", "=", " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"res", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"res", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "/.", " ", 
               RowBox[{"exprBef", "\[Rule]", " ", "exprAfter"}]}]}], "}"}]}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", " ", 
           RowBox[{"Length", "[", "Para", "]"}]}], ",", " ", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"res", " ", "=", " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Append", "[", 
               RowBox[{
                RowBox[{"res", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"Para", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{"Append", "[", 
               RowBox[{
                RowBox[{"res", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"resDiff", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "4", "]"}], "]"}]}], "]"}]}], "}"}]}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"rpRuleSet", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", " ", 
           RowBox[{"Length", "[", "resDiff", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", "=", "1"}], ",", 
            RowBox[{"j", "\[LessEqual]", " ", 
             RowBox[{"Length", "[", 
              RowBox[{
               RowBox[{"resDiff", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "5", "]"}], "]"}], "]"}]}], ",", 
            RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"rpRuleSet", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"resDiff", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", 
                RowBox[{"[", "5", "]"}], "]"}], "[", 
               RowBox[{"[", "j", "]"}], "]"}]}], "]"}]}], 
           "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", " ", 
           RowBox[{"Length", "[", "rpRuleSet", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"rpRule", "=", 
            RowBox[{"rpRuleSet", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"rprLeft", "=", 
            RowBox[{"rpRule", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"rprRight", "=", 
            RowBox[{"rpRule", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"rpr2Equation", "=", 
            RowBox[{"rprLeft", "\[Equal]", "rprRight"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"rprVariants", "=", " ", 
            RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"varlist", "=", 
            RowBox[{"Variables", "[", "rprRight", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"i", "=", "1"}], ",", 
             RowBox[{"i", "\[LessEqual]", 
              RowBox[{"Length", "[", "varlist", "]"}]}], ",", 
             RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"rprVariants", ",", 
               RowBox[{
                RowBox[{"Solve", "[", 
                 RowBox[{"rpr2Equation", ",", 
                  RowBox[{"varlist", "[", 
                   RowBox[{"[", "i", "]"}], "]"}]}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], 
            "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"Delete", " ", "the", " ", "replaced", " ", "variable"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"delVarIdx", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", " ", 
           RowBox[{"Length", "[", "rprVariants", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"rpVar", " ", "=", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"rprVariants", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"j", "=", "1"}], ",", 
          RowBox[{"j", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"res", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ",", 
          RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "1"}], ",", 
            RowBox[{"i", "\[LessEqual]", " ", 
             RowBox[{"Length", "[", "rprVariants", "]"}]}], ",", 
            RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"rpVar", " ", "=", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"rprVariants", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"ToString", "[", "rpVar", "]"}], "==", 
                RowBox[{"ToString", "[", 
                 RowBox[{
                  RowBox[{"res", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"delVarIdx", ",", "j"}], "]"}], ",", "True"}], 
              "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"finalVar", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"finalD", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"j", "=", "1"}], ",", 
          RowBox[{"j", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"res", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ",", 
          RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "1"}], ",", 
            RowBox[{"i", "\[LessEqual]", 
             RowBox[{"Length", "[", "delVarIdx", "]"}]}], ",", 
            RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"delVarIdx", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "\[NotEqual]", " ", "j"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"finalVar", ",", 
                 RowBox[{
                  RowBox[{"res", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"finalD", ",", 
                 RowBox[{
                  RowBox[{"res", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "j", "]"}], "]"}]}], "]"}]}], ",", 
              "\[IndentingNewLine]", "True"}], "]"}]}], "\[IndentingNewLine]",
            "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]",
         "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"finalVar", ",", "finalD"}], "}"}], ",", 
          RowBox[{"Append", "[", 
           RowBox[{"rprVariants", ",", "rpRuleSet"}], "]"}]}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "This", " ", "section", " ", "process", " ", "the", " ", "constraints", 
     " ", "from", " ", "Isabelle"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"transSubstF", "[", "substF_", "]"}], " ", ":=", " ", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "h", ",", "ruleSet", ",", " ", "sub", ",", "resRSet", ",", "resExpr", 
         ",", "subRSet", ",", "subExpr", ",", "i"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"h", "=", 
         RowBox[{"Head", "[", "substF", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"resRSet", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Switch", "[", 
         RowBox[{"h", ",", "\[IndentingNewLine]", "List", ",", " ", 
          RowBox[{
           RowBox[{"ruleSet", "=", 
            RowBox[{"substF", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"sub", " ", "=", " ", 
            RowBox[{"transSubstF", "[", 
             RowBox[{"substF", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"i", "=", "1"}], ",", 
             RowBox[{"i", "<", 
              RowBox[{"Length", "[", "ruleSet", "]"}]}], ",", 
             RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"resRSet", ",", 
               RowBox[{"ruleSet", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"subRSet", "=", 
            RowBox[{"sub", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"i", "=", "1"}], ",", 
             RowBox[{"i", "<", 
              RowBox[{"Length", "[", "subRSet", "]"}]}], ",", 
             RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"resRSet", ",", " ", 
               RowBox[{"subRSet", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"resExpr", "=", 
            RowBox[{"sub", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
          ",", "\[IndentingNewLine]", "_", ",", 
          RowBox[{"resExpr", "=", "substF"}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"resRSet", ",", "Null"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"resRSet", ",", "resExpr"}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"transSubstCons", "[", "Cons_", "]"}], " ", ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"substF", ",", "resRSet", ",", "resExpr", ",", "i"}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"substF", "=", 
         RowBox[{"transSubstF", "[", 
          RowBox[{"Cons", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"resRSet", "=", " ", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", " ", 
          RowBox[{"i", "<", 
           RowBox[{"Length", "[", 
            RowBox[{"substF", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"resRSet", ",", 
            RowBox[{
             RowBox[{"substF", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], " ", "]"}]}], " ", 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Cons", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"substF", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", "resRSet"}], "}"}]}], 
         "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"applyRPR2Subst", "[", 
      RowBox[{"cons_", ",", "rprSet_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "rpRule", ",", "substrSet", ",", "substRule", ",", "i", ",", "j", ",",
          "substrLeft", ",", "substrRight", ",", "rprLeft", ",", "rprRigth", 
         ",", "midLeft", ",", "midRight", ",", "resLeft", ",", "resRight", 
         ",", "resRule", ",", "varlist", ",", "tmp", ",", "k", ",", "res", 
         ",", "resSubstrSet", ",", "resSubstRule"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"substrSet", "=", 
         RowBox[{
          RowBox[{"cons", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"resRule", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", "rprSet", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"rpRule", "=", 
            RowBox[{
             RowBox[{"rprSet", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"rprLeft", "=", 
            RowBox[{"rpRule", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"rprRigth", "=", 
            RowBox[{"rpRule", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"resSubstrSet", "=", 
            RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"j", "=", "1"}], ",", 
             RowBox[{"j", "\[LessEqual]", 
              RowBox[{"Length", "[", "substrSet", "]"}]}], ",", 
             RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"substRule", "=", 
               RowBox[{"substrSet", "[", 
                RowBox[{"[", "j", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"substrLeft", "=", 
               RowBox[{"substRule", "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"substrRight", "=", 
               RowBox[{"substRule", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"resSubstRule", "=", 
               RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"ToString", "[", "rprLeft", "]"}], "\[Equal]", 
                 RowBox[{"ToString", "[", "substrLeft", "]"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"midLeft", "=", "rprRigth"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"midRight", "=", 
                  RowBox[{"substrRight", "/.", "rpRule"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"varlist", "=", 
                  RowBox[{"Variables", "[", "midLeft", "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"For", "[", 
                  RowBox[{
                   RowBox[{"k", "=", "1"}], ",", 
                   RowBox[{"k", "\[LessEqual]", 
                    RowBox[{"Length", "[", "varlist", "]"}]}], ",", 
                   RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"resLeft", "=", 
                    RowBox[{"varlist", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"tmp", "=", 
                    RowBox[{"midLeft", "/", "resLeft"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"resRight", "=", 
                    RowBox[{"midRight", "/", "tmp"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"resSubstRule", ",", 
                    RowBox[{"{", 
                    RowBox[{"resLeft", ",", "resRight"}], "}"}]}], "]"}]}]}], 
                  "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"resSubstRule", ",", " ", "substRule"}], "]"}]}], 
               "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"resSubstrSet", ",", "resSubstRule"}], "]"}]}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"tmp", "=", 
            RowBox[{"Tuples", "[", "resSubstrSet", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"resRule", "=", 
            RowBox[{"Join", "[", 
             RowBox[{"resRule", ",", "tmp"}], "]"}]}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", " ", 
           RowBox[{"Length", "[", "resRule", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"res", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"cons", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"cons", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                RowBox[{"resRule", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], "}"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", "res"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"transODECons", "[", "Cons_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "oldODE", ",", "newODE", ",", "tmp", ",", "rpRules", ",", "Domain"}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"oldODE", "=", 
         RowBox[{
          RowBox[{"Cons", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"tmp", "=", 
         RowBox[{"PolyDiff", "[", 
          RowBox[{
           RowBox[{"oldODE", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"oldODE", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"newODE", "=", 
         RowBox[{"tmp", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRules", "=", 
         RowBox[{"tmp", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Domain", "=", 
         RowBox[{
          RowBox[{"Cons", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", "result", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"newODE", ",", "Domain"}], "}"}], ",", "rpRules"}], 
         "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"processGNCInput", "[", "input_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "cons1", ",", "cons2", ",", "cons3", ",", "cons4", ",", "cons5", ",", 
         "tmp", ",", "allCons", ",", "rpRules", ",", "res", ",", "cons3Set", 
         ",", "i"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"tmp", "=", 
          RowBox[{"StringReplace", "[", 
           RowBox[{"input", ",", 
            RowBox[{"\"\<_\>\"", "\[Rule]", "\"\<0\>\""}]}], "]"}]}], ";"}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"tmp", "=", 
         RowBox[{"StringReplace", "[", 
          RowBox[{"input", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\"\<plant_t\>\"", "\[Rule]", "\"\<t\>\""}], ",", 
             RowBox[{"\"\<plant_v1_1\>\"", "\[Rule]", "\"\<v\>\""}], ",", 
             RowBox[{"\"\<plant_m1_1\>\"", "\[Rule]", "\"\<m\>\""}], ",", 
             RowBox[{"\"\<control_1\>\"", "\[Rule]", "\"\<Fc\>\""}], ",", 
             RowBox[{"\"\<plant_r1_1\>\"", "\[Rule]", "\"\<r\>\""}], ",", 
             RowBox[{"\"\<_\>\"", "\[Rule]", "\"\<0\>\""}]}], "}"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"allCons", "=", 
         RowBox[{"ToExpression", "[", "tmp", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"cons1", "=", 
         RowBox[{"allCons", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"cons2", "=", 
         RowBox[{"allCons", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"cons3", "=", 
         RowBox[{"allCons", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"cons4", "=", 
         RowBox[{"allCons", "[", 
          RowBox[{"[", "4", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"cons5", "=", 
         RowBox[{"allCons", "[", 
          RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"Transform", " ", "the", " ", "constraints"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"rpRules", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"cons3", "=", 
         RowBox[{"transSubstCons", "[", "cons3", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"tmp", "=", 
         RowBox[{"transODECons", "[", "cons4", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"cons4", "=", 
         RowBox[{"tmp", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRules", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"rpRules", ",", 
           RowBox[{"tmp", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"tmp", "=", 
         RowBox[{"transODECons", "[", "cons5", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"cons5", "=", 
         RowBox[{"tmp", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rpRules", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"rpRules", ",", 
           RowBox[{"tmp", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"cons3Set", "=", 
         RowBox[{"applyRPR2Subst", "[", 
          RowBox[{"cons3", ",", "rpRules"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", "cons3Set", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"res", ",", 
            RowBox[{"{", 
             RowBox[{"cons1", ",", "cons2", ",", 
              RowBox[{"cons3Set", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "cons4", ",", "cons5"}], 
             "}"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "res"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "This", " ", "is", " ", "the", " ", "constraints", " ", "string", " ", 
     "from", " ", "Isabelle"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "input", "=", 
     "\"\<{{(Inv&&((plant_t<(16 / 125))&&(plant_t>=(0)))) \
,(((plant_v1_1+(2))<(1 / 20))&&((plant_v1_1+(2))>(- (1 / \
20))))},{((plant_v1_1==(- 2))&&((plant_m1_1==(1250))&&((control_1==(4055 / \
2))&&(plant_t==(0))))) ,Inv},{((plant_t==(16 / 125))&&Inv) \
,{{{plant_t,(0)},Null},{{{control_1,plant_m1_1*(((811 / 500)-(1 / \
100)*(control_1/plant_m1_1-(811 / 500)))-(3 / \
5)*(plant_v1_1+(2)))},Null},Inv}}},{{{{plant_v1_1, plant_m1_1, plant_r1_1, \
plant_t},{(control_1/plant_m1_1) - 1.622, -(control_1/2548), plant_v1_1, \
1}},((plant_t<(16 / 125))&&(plant_t>=(0)))} ,Inv},{{{{plant_v1_1, plant_m1_1, \
plant_r1_1, plant_t},{(control_1/plant_m1_1) - 1.622, -(control_1/2842), \
plant_v1_1, 1}},((plant_t<(16 / 125))&&(plant_t>=(0)))} ,Inv},Null}\>\""}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Process", " ", "the", " ", "constrains", " ", "by", " ", 
     "processGNCInput"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"processGNCInput", "[", "input", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6314916611073527`*^9, 3.631491812386099*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Inv", "&&", 
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "+", "v"}], "<", 
         FractionBox["1", "20"]}], "&&", 
        RowBox[{
         RowBox[{"2", "+", "v"}], ">", 
         RowBox[{"-", 
          FractionBox["1", "20"]}]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"v", "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"m", "\[Equal]", "1250"}], "&&", 
        RowBox[{"Fc", "\[Equal]", 
         FractionBox["4055", "2"]}], "&&", 
        RowBox[{"t", "\[Equal]", "0"}]}], ",", "Inv"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"t", "\[Equal]", 
         FractionBox["16", "125"]}], "&&", "Inv"}], ",", 
       RowBox[{"{", 
        RowBox[{"Inv", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"t", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", 
             FractionBox[
              RowBox[{"m", " ", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox["811", "500"], "-", 
                 FractionBox[
                  RowBox[{"3", " ", 
                   RowBox[{"(", 
                    RowBox[{"2", "+", "v"}], ")"}]}], "5"], "+", 
                 RowBox[{
                  FractionBox["1", "100"], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    FractionBox["811", "500"], "-", "w1"}], ")"}]}]}], 
                ")"}]}], "w1"]}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w1", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w1", "2"], "2548"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w1"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w2", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w2", "2"], "2842"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w2"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Inv", "&&", 
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "+", "v"}], "<", 
         FractionBox["1", "20"]}], "&&", 
        RowBox[{
         RowBox[{"2", "+", "v"}], ">", 
         RowBox[{"-", 
          FractionBox["1", "20"]}]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"v", "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"m", "\[Equal]", "1250"}], "&&", 
        RowBox[{"Fc", "\[Equal]", 
         FractionBox["4055", "2"]}], "&&", 
        RowBox[{"t", "\[Equal]", "0"}]}], ",", "Inv"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"t", "\[Equal]", 
         FractionBox["16", "125"]}], "&&", "Inv"}], ",", 
       RowBox[{"{", 
        RowBox[{"Inv", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"t", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"w1", ",", 
             RowBox[{
              FractionBox["811", "500"], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                RowBox[{"(", 
                 RowBox[{"2", "+", "v"}], ")"}]}], "5"], "+", 
              RowBox[{
               FractionBox["1", "100"], " ", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox["811", "500"], "-", "w1"}], ")"}]}]}]}], "}"}]}],
           "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w1", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w1", "2"], "2548"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w1"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w2", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w2", "2"], "2842"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w2"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Inv", "&&", 
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "+", "v"}], "<", 
         FractionBox["1", "20"]}], "&&", 
        RowBox[{
         RowBox[{"2", "+", "v"}], ">", 
         RowBox[{"-", 
          FractionBox["1", "20"]}]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"v", "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"m", "\[Equal]", "1250"}], "&&", 
        RowBox[{"Fc", "\[Equal]", 
         FractionBox["4055", "2"]}], "&&", 
        RowBox[{"t", "\[Equal]", "0"}]}], ",", "Inv"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"t", "\[Equal]", 
         FractionBox["16", "125"]}], "&&", "Inv"}], ",", 
       RowBox[{"{", 
        RowBox[{"Inv", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"t", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"Fc", ",", 
             RowBox[{"m", " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox["811", "500"], "+", 
                RowBox[{
                 FractionBox["1", "100"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   FractionBox["811", "500"], "-", 
                   FractionBox["Fc", "m"]}], ")"}]}], "-", 
                FractionBox[
                 RowBox[{"3", " ", 
                  RowBox[{"(", 
                   RowBox[{"2", "+", "v"}], ")"}]}], "5"]}], ")"}]}]}], 
            "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w1", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w1", "2"], "2548"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w1"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w2", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w2", "2"], "2842"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w2"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Inv", "&&", 
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "+", "v"}], "<", 
         FractionBox["1", "20"]}], "&&", 
        RowBox[{
         RowBox[{"2", "+", "v"}], ">", 
         RowBox[{"-", 
          FractionBox["1", "20"]}]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"v", "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"m", "\[Equal]", "1250"}], "&&", 
        RowBox[{"Fc", "\[Equal]", 
         FractionBox["4055", "2"]}], "&&", 
        RowBox[{"t", "\[Equal]", "0"}]}], ",", "Inv"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"t", "\[Equal]", 
         FractionBox["16", "125"]}], "&&", "Inv"}], ",", 
       RowBox[{"{", 
        RowBox[{"Inv", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"t", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"Fc", ",", 
             RowBox[{"m", " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox["811", "500"], "+", 
                RowBox[{
                 FractionBox["1", "100"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   FractionBox["811", "500"], "-", 
                   FractionBox["Fc", "m"]}], ")"}]}], "-", 
                FractionBox[
                 RowBox[{"3", " ", 
                  RowBox[{"(", 
                   RowBox[{"2", "+", "v"}], ")"}]}], "5"]}], ")"}]}]}], 
            "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w1", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w1", "2"], "2548"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w1"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w2", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w2", "2"], "2842"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w2"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Inv", "&&", 
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "+", "v"}], "<", 
         FractionBox["1", "20"]}], "&&", 
        RowBox[{
         RowBox[{"2", "+", "v"}], ">", 
         RowBox[{"-", 
          FractionBox["1", "20"]}]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"v", "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"m", "\[Equal]", "1250"}], "&&", 
        RowBox[{"Fc", "\[Equal]", 
         FractionBox["4055", "2"]}], "&&", 
        RowBox[{"t", "\[Equal]", "0"}]}], ",", "Inv"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"t", "\[Equal]", 
         FractionBox["16", "125"]}], "&&", "Inv"}], ",", 
       RowBox[{"{", 
        RowBox[{"Inv", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"t", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", 
             FractionBox[
              RowBox[{"m", " ", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox["811", "500"], "-", 
                 FractionBox[
                  RowBox[{"3", " ", 
                   RowBox[{"(", 
                    RowBox[{"2", "+", "v"}], ")"}]}], "5"], "+", 
                 RowBox[{
                  FractionBox["1", "100"], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    FractionBox["811", "500"], "-", "w2"}], ")"}]}]}], 
                ")"}]}], "w2"]}], "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w1", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w1", "2"], "2548"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w1"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w2", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w2", "2"], "2842"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w2"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Inv", "&&", 
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "+", "v"}], "<", 
         FractionBox["1", "20"]}], "&&", 
        RowBox[{
         RowBox[{"2", "+", "v"}], ">", 
         RowBox[{"-", 
          FractionBox["1", "20"]}]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"v", "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"m", "\[Equal]", "1250"}], "&&", 
        RowBox[{"Fc", "\[Equal]", 
         FractionBox["4055", "2"]}], "&&", 
        RowBox[{"t", "\[Equal]", "0"}]}], ",", "Inv"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"t", "\[Equal]", 
         FractionBox["16", "125"]}], "&&", "Inv"}], ",", 
       RowBox[{"{", 
        RowBox[{"Inv", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"t", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"w2", ",", 
             RowBox[{
              FractionBox["811", "500"], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                RowBox[{"(", 
                 RowBox[{"2", "+", "v"}], ")"}]}], "5"], "+", 
              RowBox[{
               FractionBox["1", "100"], " ", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox["811", "500"], "-", "w2"}], ")"}]}]}]}], "}"}]}],
           "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w1", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w1", "2"], "2548"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w1"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w2", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w2", "2"], "2842"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w2"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Inv", "&&", 
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "+", "v"}], "<", 
         FractionBox["1", "20"]}], "&&", 
        RowBox[{
         RowBox[{"2", "+", "v"}], ">", 
         RowBox[{"-", 
          FractionBox["1", "20"]}]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"v", "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"m", "\[Equal]", "1250"}], "&&", 
        RowBox[{"Fc", "\[Equal]", 
         FractionBox["4055", "2"]}], "&&", 
        RowBox[{"t", "\[Equal]", "0"}]}], ",", "Inv"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"t", "\[Equal]", 
         FractionBox["16", "125"]}], "&&", "Inv"}], ",", 
       RowBox[{"{", 
        RowBox[{"Inv", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"t", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"Fc", ",", 
             RowBox[{"m", " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox["811", "500"], "+", 
                RowBox[{
                 FractionBox["1", "100"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   FractionBox["811", "500"], "-", 
                   FractionBox["Fc", "m"]}], ")"}]}], "-", 
                FractionBox[
                 RowBox[{"3", " ", 
                  RowBox[{"(", 
                   RowBox[{"2", "+", "v"}], ")"}]}], "5"]}], ")"}]}]}], 
            "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w1", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w1", "2"], "2548"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w1"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w2", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w2", "2"], "2842"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w2"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Inv", "&&", 
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "+", "v"}], "<", 
         FractionBox["1", "20"]}], "&&", 
        RowBox[{
         RowBox[{"2", "+", "v"}], ">", 
         RowBox[{"-", 
          FractionBox["1", "20"]}]}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"v", "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"m", "\[Equal]", "1250"}], "&&", 
        RowBox[{"Fc", "\[Equal]", 
         FractionBox["4055", "2"]}], "&&", 
        RowBox[{"t", "\[Equal]", "0"}]}], ",", "Inv"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"t", "\[Equal]", 
         FractionBox["16", "125"]}], "&&", "Inv"}], ",", 
       RowBox[{"{", 
        RowBox[{"Inv", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"t", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"Fc", ",", 
             RowBox[{"m", " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox["811", "500"], "+", 
                RowBox[{
                 FractionBox["1", "100"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   FractionBox["811", "500"], "-", 
                   FractionBox["Fc", "m"]}], ")"}]}], "-", 
                FractionBox[
                 RowBox[{"3", " ", 
                  RowBox[{"(", 
                   RowBox[{"2", "+", "v"}], ")"}]}], "5"]}], ")"}]}]}], 
            "}"}]}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w1", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w1", "2"], "2548"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w1"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"w2", ",", "v", ",", "r", ",", "t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            SuperscriptBox["w2", "2"], "2842"], ",", 
           RowBox[{
            RowBox[{"-", "1.622`"}], "+", "w2"}], ",", "v", ",", "1"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"t", "<", 
         FractionBox["16", "125"]}], "&&", 
        RowBox[{"t", "\[GreaterEqual]", "0"}]}]}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.6314918191514*^9}]
}, Open  ]]
},
WindowSize->{1280, 640},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
FrontEndVersion->"10.0 for Microsoft Windows (64-bit) (July 1, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 80726, 1847, 10072, "Input"],
Cell[81309, 1871, 22912, 694, 845, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
